public Client_IsValidClient(Handle plugin, numParams)
{
	int client = GetNativeCell(1);
	bool alive = GetNativeCell(2);
	bool bots = GetNativeCell(3);
	bool admin = GetNativeCell(4);

	if (client > 0 && client <= MaxClients && IsClientInGame(client) && (alive == false || IsPlayerAlive(client)) && (bots == false || !IsFakeClient(client)) && (admin == false || CheckCommandAccess(client, "sm_hostiesadmin", ADMFLAG_GENERIC)))
	{
		return true;
	}
	return false;
}
public Client_StripClientAll(Handle plugin, numParams)
{
	int client = GetNativeCell(1);

	if(Hosties3_IsClientValid(client))
	{
		bool ammo = GetNativeCell(2);

		Client_RemoveAllWeapons(client, "", ammo);
	}
	else
	{
		ThrowNativeError(SP_ERROR_NATIVE, "Client %i is invalid", client);
	}
}

public Client_StripClient(Handle plugin, numParams)
{
	int client = GetNativeCell(1);

	if(Hosties3_IsClientValid(client))
	{
		bool ammo = GetNativeCell(3);

		char weapon[32];
		GetNativeString(2, weapon, sizeof(weapon));

		Client_RemoveWeapon(client, weapon, ammo);
	}
	else
	{
		ThrowNativeError(SP_ERROR_NATIVE, "Client %i is invalid", client);
	}
}

public Client_SendOverlayToClient(Handle plugin, numParams)
{
	int client = GetNativeCell(1);

	if(Hosties3_IsClientValid(client))
	{
		char overlay[PLATFORM_MAX_PATH + 1];

		GetNativeString(2, overlay, sizeof(overlay));

		ClientCommand(client, "r_screenoverlay \"%s\"", overlay);
	}
	else
	{
		ThrowNativeError(SP_ERROR_NATIVE, "Client %i is invalid", client);
	}
}

public Client_SendOverlayToAll(Handle plugin, numParams)
{
	char overlay[PLATFORM_MAX_PATH + 1];
	GetNativeString(1, overlay, sizeof(overlay));

	Hosties3_LoopClients(i)
	{
		if (Hosties3_IsClientValid(i) && !IsFakeClient(i))
		{
			ClientCommand(i, "r_screenoverlay \"%s\"", overlay);
		}
	}	
}

// https://forums.alliedmods.net/showpost.php?p=1204522&postcount=12
public Client_GetRandomClient(Handle plugin, numParams)
{
	int team = GetNativeCell(1);
	int clients[MaxClients + 1];
	int clientCount;

	Hosties3_LoopClients(i)
	{
		if (IsClientInGame(i) && (GetClientTeam(i) == team))
		{
			clients[clientCount++] = i;
		}
	}
	return (clientCount == 0) ? -1 : clients[GetRandomInt(0, clientCount-1)];
}
