#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include <hosties3>

#define PLUGIN_NAME HOSTIES3_NAME ... "Check Players"
#define PLUGIN_AUTHOR "ESK0 & " ... HOSTIES3_AUTHOR
#define PLUGIN_CONFIG HOSTIES3_CONFIG ... "checkplayers.cfg"

int g_iEnable;
int g_iLogLevel;

char g_sTag[64];

public Plugin:myinfo =
{
	name = PLUGIN_NAME,
	author = PLUGIN_AUTHOR,
	version = HOSTIES3_VERSION,
	description = "Rewrite of SM_Hosties v2",
	url = "www.overcore.eu"
};

public Hosties3_OnPluginLoaded()
{
	Hosties3_IsLoaded();
	Hosties3_CheckGame();
	LoadTranslations("hosties3_checkplayers.phrases");
	LoadConfig();

	AddCommandListener(Event_BlockKillCommand, "kill");

	RegConsoleCmd("sm_kill", Event_KillCommand);
	RegConsoleCmd("sm_rebels", Command_Rebels);
}

public Hosties3_OnConfigsLoaded()
{
	LoadConfig();
}

public Action Command_Rebels(client, args)
{
	char sTitle[64], sNoRebels[64], sClose[64];
	int iCount = 0;

	Format(sTitle, sizeof(sTitle), "%T", "RebelsTitle", client);
	Format(sNoRebels, sizeof(sNoRebels), "%T", "NoRebels", client);
	Format(sClose, sizeof(sClose), "%T", "Close", client);

	new Handle:panel = CreatePanel();
	SetPanelTitle(panel, sTitle);
	DrawPanelText(panel, " ");
	Hosties3_LoopClients(i)
	{
		if(Hosties3_IsClientValid(i) && GetClientTeam(i) == CS_TEAM_T && Hosties3_IsClientRebel(i))
		{
			char sBuffer[64];
			Format(sBuffer, sizeof(sBuffer), "(#%d) %N", i, i);
			DrawPanelText(panel, sBuffer);
			iCount++;
		}
	}

	if(iCount == 0)
	{
		DrawPanelText(panel, sNoRebels);
	}
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, sClose);
	SendPanelToClient(panel, client, PanelHandler, 30);
	CloseHandle(panel);
}

public PanelHandler(Handle:menu, MenuAction:action, client, param2)
{
	
}

public Action Event_KillCommand(int client, args)
{
	if(g_iEnable)
	{
		ForcePlayerSuicide(client);
		
		Hosties3_LoopClients(i)
		{
			if(Hosties3_IsClientValid(i))
			{
				Hosties3_PrintToChat(i, "%T", "Suicide", i, g_sTag, client);
			}
		}
	}
}

public Action Event_BlockKillCommand(int client, const char[] command, args)
{
	if(g_iEnable)
	{
		return Plugin_Handled;
	}
	return Plugin_Continue;
}

LoadConfig()
{
	Handle hConfig = CreateKeyValues("Hosties3");

	if(!FileExists(PLUGIN_CONFIG))
	{
		SetFailState("[Hosties3] 'addons/sourcemod/configs/hosties3/checkplayers.cfg' not found!");
		return;
	}

	FileToKeyValues(hConfig, PLUGIN_CONFIG);
	if (KvJumpToKey(hConfig, "CheckPlayers"))
	{
		g_iEnable = KvGetNum(hConfig, "Enable", 1);
		g_iLogLevel = Hosties3_GetLogLevel();
		Hosties3_GetTag(g_sTag, sizeof(g_sTag));
	}
	else
	{
		SetFailState("Config for 'CheckPlayers' not found!");
		return;
	}

	if(g_iLogLevel <= 2)
	{
		Hosties3_LogFile(HOSTIES3_PATH, "checkplayers", _, DEBUG, "[CheckPlayers] Enable: %d", g_iEnable);
	}

	if(g_iEnable != 1)
	{
		SetFailState("'CheckPlayers' is deactivated!");
		return;
	}

	CloseHandle(hConfig);
}
