#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <SteamWorks>
#include <hosties3>

#define PLUGIN_NAME HOSTIES3_NAME ... "Description"
#define PLUGIN_CONFIG HOSTIES3_CONFIG ... "description.cfg"

int g_iEnable;
int g_iLogLevel;

char g_sDescription[64];

public Plugin:myinfo =
{
	name = PLUGIN_NAME,
	author = HOSTIES3_AUTHOR,
	version = HOSTIES3_VERSION,
	description = "Rewrite of SM_Hosties v2",
	url = HOSTIES3_URL
};

public Hosties3_OnPluginLoaded()
{
	Hosties3_IsLoaded();
	Hosties3_CheckGame();
	LoadConfig();
	SetDescription();
}

public Hosties3_OnConfigsLoaded()
{
	LoadConfig();
	SetDescription();
}

SetDescription()
{
	SteamWorks_SetGameDescription(g_sDescription);

	if(g_iLogLevel <= 2)
	{
		Hosties3_LogFile(HOSTIES3_PATH, "description", _, DEBUG, "[Description] Descroption set to %s", g_sDescription);
	}
}

LoadConfig()
{
	Handle hConfig = CreateKeyValues("Hosties3");

	if(!FileExists(PLUGIN_CONFIG))
	{
		SetFailState("[Hosties3] 'addons/sourcemod/configs/hosties3/description.cfg' not found!");
		return;
	}

	FileToKeyValues(hConfig, PLUGIN_CONFIG);
	if (KvJumpToKey(hConfig, "Description"))
	{
		g_iEnable = KvGetNum(hConfig, "Enable", 1);
		g_iLogLevel = Hosties3_GetLogLevel();
		KvGetString(hConfig, "Description", g_sDescription, sizeof(g_sDescription));
	}
	else
	{
		SetFailState("Config for 'Description' not found!");
		return;
	}

	if(g_iLogLevel <= 2)
	{
		if(StrEqual(g_sDescription, "", false))
		{
			SetFailState("[Hosties3] No description found!");
			return;
		}

		Hosties3_LogFile(HOSTIES3_PATH, "description", _, DEBUG, "[Description] Enable: %d", g_iEnable);
		Hosties3_LogFile(HOSTIES3_PATH, "description", _, DEBUG, "[Description] Description: %s", g_sDescription);
	}

	if(g_iEnable != 1)
	{
		SetFailState("'Description' is deactivated!");
		return;
	}

	CloseHandle(hConfig);
}