#pragma semicolon 1

#include <sourcemod>
#include <hosties3>

#define PLUGIN_NAME HOSTIES3_NAME ... "EXAMPLE"
#define PLUGIN_CONFIG HOSTIES3_CONFIG ... "example.cfg"

int g_iEnable;
int g_iLogLevel;

public Plugin:myinfo =
{
	name = PLUGIN_NAME,
	author = HOSTIES3_AUTHOR,
	version = HOSTIES3_VERSION,
	description = "Rewrite of SM_Hosties v2",
	url = HOSTIES3_URL
};

public Hosties3_OnPluginLoaded()
{
	Hosties3_IsLoaded();
	Hosties3_CheckGame();

	LoadConfig();
}

public Hosties3_OnConfigsLoaded()
{
	LoadConfig();
}

LoadConfig()
{
	Handle hConfig = CreateKeyValues("Hosties3");

	if(!FileExists(PLUGIN_CONFIG))
	{
		SetFailState("[Hosties3] 'addons/sourcemod/configs/hosties3/example.cfg' not found!");
		return;
	}

	FileToKeyValues(hConfig, PLUGIN_CONFIG);
	if (KvJumpToKey(hConfig, "Example"))
	{
		g_iEnable = KvGetNum(hConfig, "Enable", 1);
		g_iLogLevel = Hosties3_GetLogLevel();
	}
	else
	{
		SetFailState("Config for EXAMPLE not found!");
		return;
	}

	if(g_iLogLevel <= 2)
	{
		Hosties3_LogFile(HOSTIES3_PATH, "example", _, DEBUG, "[EXAMPLE] Enable: %d", g_iEnable);
	}

	if(g_iEnable != 1)
	{
		SetFailState("EXAMPLE is deactivated!");
		return;
	}

	CloseHandle(hConfig);
}