#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include <hosties3>

#define PLUGIN_NAME HOSTIES3_NAME ... "Overlays"
#define PLUGIN_AUTHOR "ESK0 & " ... HOSTIES3_AUTHOR
#define PLUGIN_CONFIG HOSTIES3_CONFIG ... "overlays.cfg"

int g_iEnable;
int g_iEnableOnDied;
int g_iLogLevel;

int g_iCTRoundEndCount;
int g_iTRoundEndCount;
char g_sCTRoundEndOverlay[PLATFORM_MAX_PATH + 1];
char g_sTRoundEndOverlay[PLATFORM_MAX_PATH + 1];

int g_iCTPlayerDeathCount;
int g_iTPlayerDeathCount;
char g_sCTPlayerDeathOverlay[PLATFORM_MAX_PATH + 1];
char g_sTPlayerDeathOverlay[PLATFORM_MAX_PATH + 1];

public Plugin:myinfo =
{
	name = PLUGIN_NAME,
	author = PLUGIN_AUTHOR,
	version = HOSTIES3_VERSION,
	description = "Rewrite of SM_Hosties v2",
	url = "www.overcore.eu"
};

public Hosties3_OnPluginLoaded()
{
	Hosties3_IsLoaded();
	Hosties3_CheckGame();
	LoadConfig();
}

public Hosties3_OnConfigsLoaded()
{
	LoadConfig();
}

public Hosties3_OnPlayerDeath(int victim, int attacker)
{
	if(g_iEnableOnDied)
	{
		if(Hosties3_IsClientValid(victim && attacker))
		{
			if(GetClientTeam(victim) == CS_TEAM_CT && victim != attacker)
			{
				if(g_iCTPlayerDeathCount == 1)
				{
					char sBuffer[PLATFORM_MAX_PATH + 1];
					Format(sBuffer, sizeof(sBuffer), "%s1", g_sCTPlayerDeathOverlay);
					Hosties3_SendOverlayToAll(sBuffer);
				}
				else
				{
					int j = GetRandomInt(1, g_iCTPlayerDeathCount);
					char sBuffer[PLATFORM_MAX_PATH + 1];
					Format(sBuffer, sizeof(sBuffer), "%s%d", g_sCTPlayerDeathOverlay, j);
					Hosties3_SendOverlayToAll(sBuffer);
				}
				CreateTimer(5.0, Event_RemoveOverlayOnDied, victim);
			}
			else if(GetClientTeam(victim) == CS_TEAM_T && victim != attacker)
			{
				if(g_iTPlayerDeathCount == 1)
				{
					char sBuffer[PLATFORM_MAX_PATH + 1];
					Format(sBuffer, sizeof(sBuffer), "%s1", g_sTPlayerDeathOverlay);
					Hosties3_SendOverlayToAll(sBuffer);
				}
				else
				{
					int j = GetRandomInt(1, g_iTPlayerDeathCount);
					char sBuffer[PLATFORM_MAX_PATH + 1];
					Format(sBuffer, sizeof(sBuffer), "%s%d", g_sTPlayerDeathOverlay, j);
					Hosties3_SendOverlayToAll(sBuffer);
				}
				CreateTimer(5.0, Event_RemoveOverlayOnDied, victim);
			}
		}
	}
}

public Action Event_RemoveOverlayOnDied(Handle: timer, any: victim)
{
	if(g_iEnableOnDied)
	{
		if(Hosties3_IsClientValid(victim))
		{
			Hosties3_SendOverlayToClient(victim, "");
		}
	}
}

public Hosties3_OnRoundEnd(int winner)
{
	if(g_iEnable)
	{
		if (winner == CS_TEAM_CT)
		{
			if(g_iCTRoundEndCount == 1)
			{
				char sBuffer[PLATFORM_MAX_PATH + 1];
				Format(sBuffer, sizeof(sBuffer), "%s1", g_sCTRoundEndOverlay);
				Hosties3_SendOverlayToAll(sBuffer);
			}
			else
			{
				int j = GetRandomInt(1, g_iCTRoundEndCount);
				char sBuffer[PLATFORM_MAX_PATH + 1];
				Format(sBuffer, sizeof(sBuffer), "%s%d", g_sCTRoundEndOverlay, j);
				Hosties3_SendOverlayToAll(sBuffer);
			}
		}
		else if(winner == CS_TEAM_T)
		{
			if(g_iTRoundEndCount == 1)
			{
				char sBuffer[PLATFORM_MAX_PATH + 1];
				Format(sBuffer, sizeof(sBuffer), "%s1", g_sTRoundEndOverlay);
				Hosties3_SendOverlayToAll(sBuffer);
			}
			else
			{
				int j = GetRandomInt(1, g_iTRoundEndCount);
				char sBuffer[PLATFORM_MAX_PATH + 1];
				Format(sBuffer, sizeof(sBuffer), "%s%d", g_sTRoundEndOverlay, j);
				Hosties3_SendOverlayToAll(sBuffer);
			}
		}
	}
}

public Hosties3_OnRoundStart()
{
	if(g_iEnable || g_iEnableOnDied)
	{
		Hosties3_SendOverlayToAll("");
	}
}

LoadConfig()
{
	Handle hConfig = CreateKeyValues("Hosties3");

	if(!FileExists(PLUGIN_CONFIG))
	{
		SetFailState("[Hosties3] 'addons/sourcemod/configs/hosties3/overlays.cfg' not found!");
		return;
	}

	FileToKeyValues(hConfig, PLUGIN_CONFIG);

	if (KvJumpToKey(hConfig, "Overlays"))
	{
		g_iEnable = KvGetNum(hConfig, "Enable", 1);
		g_iLogLevel = Hosties3_GetLogLevel();
		g_iCTRoundEndCount = KvGetNum(hConfig, "CTCount", 2);
		g_iTRoundEndCount = KvGetNum(hConfig, "TCount", 2);

		if(g_iLogLevel <= 2)
		{
			Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] RoundEnd - Enable - %d", g_iEnable);
			Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] RoundEnd - CT Count - %d", g_iCTRoundEndCount);
			Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] RoundEnd - T Count - %d", g_iTRoundEndCount);
		}

		for(int i = 1; i <= g_iCTRoundEndCount; i++)
		{
			KvGetString(hConfig, "CTBase", g_sCTRoundEndOverlay, sizeof(g_sCTRoundEndOverlay));

			char sBuffer[PLATFORM_MAX_PATH + 1];
			Format(sBuffer, sizeof(sBuffer), "%s%d", g_sCTRoundEndOverlay, i);

			char sMaterial[PLATFORM_MAX_PATH + 1];
			Format(sMaterial, sizeof(sMaterial), "%s.vmt", sBuffer);

			char sTexture[PLATFORM_MAX_PATH + 1];
			Format(sTexture, sizeof(sTexture), "%s.vtf", sBuffer);

			PrecacheGeneric(sMaterial, true);
			PrecacheGeneric(sMaterial, true);
			AddFileToDownloadsTable(sTexture);
			AddFileToDownloadsTable(sTexture);

			if(g_iLogLevel <= 2)
			{
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] RoundEnd - CT Overlay - %d - %s", i, sBuffer);
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] RoundEnd - CT Overlay Material - %d - %s", i, sMaterial);
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] RoundEnd - CT Overlay Texture - %d - %s", i, sTexture);
			}
		}

		for(int i = 1; i <= g_iTRoundEndCount; i++)
		{
			KvGetString(hConfig, "TBase", g_sTRoundEndOverlay, sizeof(g_sTRoundEndOverlay));

			char sBuffer[PLATFORM_MAX_PATH + 1];
			Format(sBuffer, sizeof(sBuffer), "%s%d", g_sTRoundEndOverlay, i);

			char sMaterial[PLATFORM_MAX_PATH + 1];
			Format(sMaterial, sizeof(sMaterial), "%s.vmt", sBuffer);

			char sTexture[PLATFORM_MAX_PATH + 1];
			Format(sTexture, sizeof(sTexture), "%s.vtf", sBuffer);

			PrecacheGeneric(sMaterial, true);
			PrecacheGeneric(sMaterial, true);
			AddFileToDownloadsTable(sTexture);
			AddFileToDownloadsTable(sTexture);

			if(g_iLogLevel <= 2)
			{
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] RoundEnd - T Overlay - %d - %s", i, sBuffer);
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] RoundEnd - T Overlay Material - %d - %s", i, sMaterial);
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] RoundEnd - T Overlay Texture - %d - %s", i, sTexture);
			}
		}
		KvGoBack(hConfig);
	}
	else
	{
		SetFailState("Config for 'Overlays' not found!");
		return;
	}

	if (KvJumpToKey(hConfig, "Overlay On Died"))
	{
		g_iEnableOnDied = KvGetNum(hConfig, "Enable", 1);
		g_iCTPlayerDeathCount = KvGetNum(hConfig, "CTCount", 2);
		g_iTPlayerDeathCount = KvGetNum(hConfig, "TCount", 2);

		if(g_iLogLevel <= 2)
		{
			Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] PlayerDeath - Enable - %d", g_iEnable);
			Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] PlayerDeath - CT Count - %d", g_iCTPlayerDeathCount);
			Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] PlayerDeath - T Count - %d", g_iTPlayerDeathCount);
		}
		
		for(int i = 1; i <= g_iCTPlayerDeathCount; i++)
		{
			KvGetString(hConfig, "CTBase", g_sCTPlayerDeathOverlay, sizeof(g_sCTPlayerDeathOverlay));

			char sBuffer[PLATFORM_MAX_PATH + 1];
			Format(sBuffer, sizeof(sBuffer), "%s%d", g_sCTPlayerDeathOverlay, i);

			char sMaterial[PLATFORM_MAX_PATH + 1];
			Format(sMaterial, sizeof(sMaterial), "%s.vmt", sBuffer);

			char sTexture[PLATFORM_MAX_PATH + 1];
			Format(sTexture, sizeof(sTexture), "%s.vtf", sBuffer);

			PrecacheGeneric(sMaterial, true);
			PrecacheGeneric(sMaterial, true);
			AddFileToDownloadsTable(sTexture);
			AddFileToDownloadsTable(sTexture);

			if(g_iLogLevel <= 2)
			{
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] PlayerDeath - CT Overlay - %d - %s", i, sBuffer);
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] PlayerDeath - CT Overlay Material - %d - %s", i, sMaterial);
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] PlayerDeath - CT Overlay Texture - %d - %s", i, sTexture);
			}
		}

		for(int i = 1; i <= g_iTPlayerDeathCount; i++)
		{
			KvGetString(hConfig, "TBase", g_sTPlayerDeathOverlay, sizeof(g_sTPlayerDeathOverlay));

			char sBuffer[PLATFORM_MAX_PATH + 1];
			Format(sBuffer, sizeof(sBuffer), "%s%d", g_sTPlayerDeathOverlay, i);

			char sMaterial[PLATFORM_MAX_PATH + 1];
			Format(sMaterial, sizeof(sMaterial), "%s.vmt", sBuffer);


			char sTexture[PLATFORM_MAX_PATH + 1];
			Format(sTexture, sizeof(sTexture), "%s.vtf", sBuffer);


			PrecacheGeneric(sMaterial, true);
			PrecacheGeneric(sMaterial, true);
			AddFileToDownloadsTable(sTexture);
			AddFileToDownloadsTable(sTexture);

			if(g_iLogLevel <= 2)
			{
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] PlayerDeath - T Overlay - %d - %s", i, sBuffer);
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] PlayerDeath - T Overlay Material - %d - %s", i, sMaterial);
				Hosties3_LogFile(HOSTIES3_PATH, "overlays", _, DEBUG, "[Overlays] PlayerDeath - T Overlay Texture - %d - %s", i, sTexture);
			}
		}
	}
	else
	{
		SetFailState("Config for 'Overlays' not found!");
		return;
	}

	if(g_iEnable != 1)
	{
		SetFailState("'Overlays' is deactivated!");
		return;
	}

	CloseHandle(hConfig);
}
